; KompleteKontrolSamp.jss
; add on scripts for the Komplete Kontrol plugin in samplitude

include"HJConst.jsh"
include"HJGlobal.jsh"
include"HJHelp.jsh"
include"common.jsm"
include "Samplitude.jsh"
include "SamplitudeStrings.jsh"
include "Samplitude.jsm"
include "SamplitudeExternalScriptHelp.jsm"
include "SamplitudeVIPMainOperations.jsm"
include "SamplitudeVIPObjects.jsm"
include "SamplitudeVIPRanges.jsm"
include "SamplitudeVIPAutomation.jsm"
include "SamplitudeVIPFXShortcuts.jsm"
include "SamplitudeVIPWindows.jsm"
include "SamplitudeVIPZooming.jsm"
include "SamplitudeVIPMisc.jsm"
include "SamplitudeLocations.jsl"
include "SamplitudeDefaultDialogLocations.jsl"
include "SamplitudeGlobals.jsl"
include "SamplitudeVrb.jsl"	; Samplitude verbosity helper functions
Include "SamplitudeControls.jsl"
include "SamplitudeHelpTopics.jsl"
include"KompleteKontrolSamp.jsh"
include "KompleteKontrolSampGlobals.jsl"
include "UIA.jsh"


Void Function MoveCursorToTopLeft ()
MoveToTopLeft ()
SayUsingVoice(VCTX_MESSAGE, "Moved to top left", OT_STRING)
EndFunction

Void Function AutoStartEvent ()
SetFocus(GetKompleteKontrol ())
Let giEditField = 0
EndFunction

Script SayLocation ()
If (giLocationFunctionIDKBD) Then
	; we have already scheduled our handler, but we dont want it any more
	UnScheduleFunction (giLocationFunctionIDKBD)
EndIf

Let giLocationPressesKBD = giLocationPressesKBD+1 ; count presses
Let giLocationFunctionIDKBD = ScheduleFunction( "SayLocationHandler", KeyTimeOut)
EndScript

String Function SayLocationHandler ()
Var
	String strLocation

Let strLocation = GetLocation()
If IsVSTPluginFXForNav() Then
If (giLocationPressesKBD == 2) Then
	SayUsingVoice (VCTX_MESSAGE, msgLoadedVST, OT_STRING)
	SayLoadedVSTTitle ()
ElIf (giLocationPressesKBD == 1) Then
SayUsingVoice (VCTX_MESSAGE, msgLocation, OT_STRING)
	SayUsingVoice (VCTX_MESSAGE,  GetLocation(), OT_STRING)
EndIf ; end of key presses for the plugin FX
Else
SayUsingVoice (VCTX_MESSAGE, msgLocation, OT_STRING)
	SayUsingVoice (VCTX_MESSAGE, strLocation, OT_STRING)
EndIf

; Reset multi-press handling as the action is now completed
Let giLocationPressesKBD = 0  
Let giLocationFunctionIDKBD = 0
EndFunction

String Function SayLoadedVSTTitle()
SayUsingVoice (VCTX_MESSAGE, GetWindowName (GetTopLevelWindow(GetFocus())), OT_STRING)
EndFunction


Int Function IsKompleteKontrolTree (Handle hwnd)
Var
	Int blnResult

If (StringContains (GetWindowName(hwnd), strKompleteKontrol)) Then
	Let blnResult = TRUE
Else
	Let blnResult = FALSE
EndIf
Return blnResult
EndFunction

Int Function IsKompleteKontrol ()
Var
	Int blnResult,
	Handle hwnd

Let blnResult = FALSE
Let hwnd = GetAppMainWindow(GetFocus())

While ((hwnd != 0) && (!IsKompleteKontrolTree(hwnd)))
Let hwnd = GetPriorWindow(hwnd)
EndWhile
Let hwnd = GetFirstChild(hwnd)
If (hwnd != 0) Then
	Let blnResult = TRUE
Else
	Let blnResult = FALSE
EndIf
Return blnResult
EndFunction

Handle Function GetKompleteKontrol ()
Var
	Handle hwnd

Let hwnd = GetAppMainWindow(GetFocus())

While ((hwnd != 0) && (!IsKompleteKontrolTree(hwnd)))
Let hwnd = GetPriorWindow(hwnd)
EndWhile

If (hwnd != 0) Then
Let hwnd = GetFirstChild(hwnd)
Let hwnd = GetFirstChild(hwnd)
EndIf
Return hwnd
EndFunction

void function ProcessEventOnFocusChangedEvent(handle AppWindow, handle RealWindow, string RealWindowName,
	handle FocusWindow, handle PrevWindow)
var int ForceSetupStuffForNewPage

if appWindow != globalPrevApp then
	;we've loaded a new app, and in case no local loadNonJCFOptions gets called,
	;but user has set something in QuickSettings and it is a NonJCF Option:
	loadNonJCFOptions ()
	; Update JCF with Global settings, purge out all prior personalized settings that were loaded.
	; This is only relevant when switching between two browser windows of the same application,
	; e.g two pages loaded in Internet Explorer or Firefox, loaded as separated windows.
	if IsMetroApp () then
	;explicitly do no Personalized Settings code,
	; even though the subsequent app window owner conditions can otherwise come true:
		ForceSetupStuffForNewPage = FALSE
	else
		ForceSetupStuffForNewPage = (StringCompare (GetWindowOwner (AppWindow), GetWindowOwner (GlobalPrevApp))
		== 0)
	EndIf
	if ForceSetupStuffForNewPage then
		SetUpStuffForNewPage (TRUE)
	endIf
endIf
let GlobalRibbonState = RibbonsActive()
if FocusChangedEventShouldProcessAncestors(FocusWindow,PrevWindow)
	ProcessSayAppWindowOnFocusChange(AppWindow, FocusWindow)
	ProcessSayRealWindowOnFocusChange(AppWindow, RealWindow, RealWindowName, FocusWindow)
	FocusChangedEventProcessAncestors(FocusWindow, PrevWindow)
	return
elif IsJavaWindow(FocusWindow) then
	JavaFocusChangedEvent (FocusWindow, PrevWindow)
	return
elif ExplorerPaneFocusChangedEvent(FocusWindow,PrevWindow) then
	return
EndIf
if GlobalRibbonState != GlobalPrevRibbonState then
	SpeakRibbonStatus(true)
EndIf
; this one seems to be the one that announces the verbose samplitude title
;ProcessSayAppWindowOnFocusChange(AppWindow,FocusWindow)
; this is the one that says the window name
ProcessSayRealWindowOnFocusChange(AppWindow,RealWindow,RealWindowName,FocusWindow)
If (!DialogActive()) Then
If IsVSTParameterFXForNav()
|| IsGetArrangerDirect() Then
	SwitchToConfiguration ("Samplitude")
Else
ProcessSayFocusWindowOnFocusChange(RealWindowName,FocusWindow)
EndIf
Else
; if it is a dialog
If IsVSTParameterFXForNav() Then
	SwitchToConfiguration ("Samplitude")
Else
ProcessSayFocusWindowOnFocusChange(RealWindowName,FocusWindow)
EndIf
EndIf
EndFunction

Void Function MoveToTopLeft ()
Var
	Handle hwnd

	Let hwnd = GetKompleteKontrol ()
	
SaveCursor()
JAWSCursor()
MoveTo (GetWindowTop (hwnd), GetWindowLeft (hwnd), COORDSYS_PIXELS)
RestoreCursor()
EndFunction

Int Function ReturnColorAtPoint ()
Var
	Int nColor,
		Int nX,
			Int nY,
				Int nResult,
					String strColor
					
					Let nX = GetCursorCol ()
					Let nY = GetCursorRow ()
					Let nColor = GetColorAtPoint (nX, nY)
					Let strColor = ColorToRGBString (nColor)
					Let nColor = StringToInt (strColor)
					Let nResult = nColor
					Return nResult
EndFunction

Script InsertQ ()
If IsKompleteKontrol () Then
SayUsingVoice(VCTX_MESSAGE, msgKompleteKontrolBuild, OT_STRING)
Endif
EndScript

Script EnterKey ()
Var
	Int nWinTypeCode,
	string strClass,
Int nID,
	Handle hwnd

Let hwnd = GetRealWindow(GetFocus())
Let nID = GetControlID( GetFocus())
Let strClass = GetWindowClass( GetFocus())
Let nWinTypeCode = GetWindowTypeCode (GetFocus(), FALSE)

If (DialogActive ()) 
|| (strClass == clsMixerEdit)
|| (strClass == clsEdit) Then
		TypeCurrentScriptKey()
		SayCurrentScriptKeyLabel()
	Return
ElIf MenusActive ()
|| UserBufferIsActive ()
|| IsVirtualPCCursor () Then
	TypeCurrentScriptKey()
	SayCurrentScriptKeyLabel()
		Return
Else
; if the user is exiting the edit field, the tab key will do this, along with re-enabling playback with the spacebar
If giEditField Then
	Let giEditField =0
		{tab}
	SayCurrentScriptKeyLabel()
		EndIf

EndIf
EndScript

Script CloseWindow ()
	SayUsingVoice (VCTX_MESSAGE, msgCloseWindow, OT_STRING)
; stop chatter
SpeechOff()
SendMessage(GetRealWindow(GetFocus()), WM_SYSCOMMAND, SC_CLOSE, 0)
; now check to see if the plugin actually closed, as problems can occur here with some plugs
If IsVSTPluginFXForNav() Then
SaveCursor()
JAWSCursor()
MoveTo (GetWindowRight (GetFocus()), GetWindowTop (GetFocus()), COORDSYS_PIXELS)
RoutePcToJAWS()
RestoreCursor()
Pause()
	SendMessage(GetRealWindow(GetFocus()), WM_SYSCOMMAND, SC_CLOSE, 0)
	SwitchToConfiguration("Samplitude")
Else
	SwitchToConfiguration("Samplitude")	
EndIf
SpeechOn()
; for some reason we don't get access on the arranger, so do a hack
{Escape}
EndScript

Script KompleteSavePatch ()
Var
	String strPatchName,
	String strUserPrefix,
	String strResult,
		Int blnResult
	
	Let blnResult = 0
	
If IsKompleteKontrol () Then
If DialogActive () Then
; we're already in the save dialog
SayUsingVoice(VCTX_PCCURSOR, msgDialogOpen, OT_STRING)
	Return
	EndIf
	Let blnResult = InputBox (strKompleteSaveAsMsg,strKompleteSaveAsTitle, strResult)
	If (!blnResult) Then
	; if they clicked cancel at the jaws input field stage
		Return
		Else
		; they have clicked enter or OK, so continue
		MoveToTopLeft ()
		SaveCursor()
			JAWSCursor()
; move to the main menu dropdown			
	MouseRight(329)
					MouseDown(55)
		Pause()
		; click here to open the menu
		LeftMouseButton()
					; move to the file sub menu
	MouseRight(15)
							MouseDown(32)
								Pause()
	LeftMouseButton()
							; move to the save as
	MouseRight(138)
							MouseDown(63)
	Delay (2)
		LeftMouseButton()
SayUsingVoice(VCTX_MESSAGE, msgPleaseWait, OT_STRING)
	Delay(15)
			
If (!DialogActive ()) Then
; this means the dialog to save did not open, hence no loaded patch
	RestoreCursor()
; close the menu
		{Escape}
			SayUsingVoice(VCTX_MESSAGE, msgKompleteNoLoadedPatchError, OT_STRING)
				Return
Else
		Delay(5)
If (!StringIsBlank (strResult)) Then
; if the user added text in the input box
; if they added their own prefix
If StringContains (strResult, strKompleteAsterisk) Then
	Let strUserPrefix = strResult
	Delay(5)
	{Home}
				Pause()
					TypeString (stringChopLeft (strUserPrefix, 1) + strKompleteDash)
	RestoreCursor()
	; copy the patch name to the clipboard so we can tell the user the full name of the patch they're saving
	Delay(2)
	{Control+A}
		Delay(2)
			{Control+C}
				Delay(2)
	Let strPatchName = GetClipboardText ()
; if the save dialog hasn't opened
If DialogActive () Then
	SayUsingVoice(VCTX_MESSAGE, msgKompleteFileName + strKompleteSpace + msgKompleteQuote + strKompleteSpace + strPatchName + strKompleteSpace + msgKompleteQuote + strKompleteFullStop, OT_STRING)
			SayUsingVoice(VCTX_MESSAGE, msgKompleteSaveFile + strKompleteFullStop + strKompleteSpace + msgKompleteReviewInformation, OT_STRING)
			Else
				SayUsingVoice(VCTX_MESSAGE, msgKompleteSaveDialogError, OT_STRING)
				EndIf
Else
; if they only typed in a new patch name without an asterisk
	Delay(5)
	;PerformScript JAWSBackspace()
{Backspace)
	Delay(2)
	TypeString (strResult)
		RestoreCursor()
	Delay(2)
; copy the patch name to the clipboard so we can tell the user the full name of the patch they're saving
	{Control+A}
		Delay(2)
			{Control+C}
	Delay(2)
If DialogActive () Then
	SayUsingVoice(VCTX_MESSAGE, msgKompleteFileName + strKompleteSpace + msgKompleteQuote + strKompleteSpace + strResult + strKompleteSpace + msgKompleteQuote + strKompleteFullStop, OT_STRING)		
	SayUsingVoice(VCTX_MESSAGE, msgKompleteSaveFile + strKompleteFullStop + strKompleteSpace + msgKompleteReviewInformation, OT_STRING)
			Else
				SayUsingVoice(VCTX_MESSAGE, msgKompleteSaveDialogError, OT_STRING)
				EndIf
EndIf
Else
; they didn't type in the input field, so put a prefix at the beginning of the existing file name
	Delay(5)
	{Home}
				Delay(2)
					TypeString (strKompleteUserEdit)
	RestoreCursor()
		; copy the patch name to the clipboard so we can tell the user the full name of the patch they're saving
		Delay(2)
	{Control+A}
			Delay(2)
	{Control+C}
				Delay(2)
	Let strPatchName = GetClipboardText ()
;if the save dialog isn't open
If DialogActive() Then 
	SayUsingVoice(VCTX_MESSAGE, msgKompleteFileName + strKompleteSpace + msgKompleteQuote + strKompleteSpace + strPatchName + strKompleteSpace + msgKompleteQuote + strKompleteFullStop, OT_STRING)
	SayUsingVoice(VCTX_MESSAGE, msgKompleteSaveFile + strKompleteFullStop + strKompleteSpace + msgKompleteReviewInformation, OT_STRING)
Else
	SayUsingVoice(VCTX_MESSAGE, msgKompleteSaveDialogError, OT_STRING)
EndIf
EndIf
	EndIf
EndIf
EndIf
EndScript

Int Function KompleteMiddleOfSearchField ()
Var
	String strSearchQuery,
	String strResult,
	Int nMove,
		Int blnResult,
			Int nButtonClick
		
		Let nButtonClick = InputBox (strKompleteSearchInputMsg,strKompleteSearchInputTitle, strResult)
	If (nButtonClick == 2)
	|| (nButtonClick == 0) Then
	; if they clicked cancel at the jaws input field stage
; move the mouse away from the edit field, as the calling function actually moved us there
		MoveToTopLeft()
	Return
		Else
		; they have clicked enter or OK, so continue
				SaveCursor()
		JAWSCursor()
; at this point we must be on the search field or the calling function has found the same colour as the search field
; if it's the search field, move up 20 pixels above it. 20 pixels allows for being at the bottom of the search field
		MouseUp(20)
; start the search for the top edge of the search field
		While nMove < 20
		If (ReturnColorAtPoint() == strKompleteSearchFieldParameter) Then
; we've found the colour surrounding the search field, so move down to the middle of it
		MouseDown(8)
RestoreCursor()
 If StringIsBlank (strResult) Then
; the user didn't type anything into the input box, so just clear any existing search text
; click to make the edit field active
	LeftMouseButton()
; select all current text and delete it
	{Control+A}
	Pause()
	{Delete}
	SayUsingVoice(VCTX_MESSAGE, msgKompleteSearchCleared, OT_STRING)
	; using the tab key at this point moves us away from the edit field to allow for playback via the spacebar. Otherwise, space would continue being passed to the edit field
	{Tab}
	Else
	; the user typed a search string into the input box
CopyToClipboard (strResult)
; click to make the edit field active
	LeftMouseButton()
; select all current text and delete it
	{Control+A}
	Pause()
	{Delete}
	Pause()
	{Control+V}
	SayUsingVoice(VCTX_MESSAGE, msgKompleteSearchResults1 + strKompleteSpace + msgKompleteQuote + strKompleteSpace + strResult + strKompleteSpace + msgKompleteQuote + strKompleteComma + strKompleteSpace + msgKompleteSearchResults2, OT_STRING)
	; using the tab key at this point moves us away from the edit field to allow for playback via the spacebar. Otherwise, space would continue being passed to the edit field
	{Tab}
	
	EndIf
; set this variable, so we know if the search for the edit field has been successful
	Let blnResult = 1
				Let nMove = 20
			Return
			Else
			MouseDown(1)
Let blnResult = 0		
	Let nMove = nMove + 1
EndIf
			EndWhile
RestoreCursor()
EndIf
		
If (!blnResult) Then
; if we don't find the parameter of the search field, hence unable to move to the middle
			SayUsingVoice(VCTX_MESSAGE, msgKompleteSearchError, OT_STRING)
			EndIf
EndFunction


Script KompleteFindSearch ()
Var
	Int nX,
		Int nY,
			Int nColor,
				String strColor,
					Int nHeight,
						Int blnResult
						
						Let blnResult = FALSE
				
SayUsingVoice(VCTX_MESSAGE, msgKompleteSearch, OT_STRING)
MoveToTopLeft()
SaveCursor()
JAWSCursor()
MouseRight(192)
				Let nX = GetCursorCol()
				Let nY = GetCursorRow()
				Let nHeight = ScreenGetHeight()
				Let nColor = GetColorAtPoint (nX, nY)
				Let strColor = GetColorName (nColor)

While nY < nHeight
If (strColor == strGray16) Then
	RestoreCursor()
Let blnResult = TRUE	
Let nHeight = 0
Else
Let nY = nY + 13
				Let nColor = GetColorAtPoint (nX, nY)
				MoveTo(nX, nY, COORDSYS_PIXELS)		
				Let strColor = GetColorName (nColor)
				Let blnResult = FALSE
EndIf
		EndWhile
RestoreCursor()

If (blnResult) Then
	KompleteMiddleOfSearchField ()
	EndIf
EndScript

Script KompleteReviewPatch ()
If IsKompleteKontrol() Then
If DialogActive () Then
	SayUsingVoice(VCTX_MESSAGE, msgKompleteReviewSavePatchName, OT_STRING)
	SayUsingVoice(VCTX_MESSAGE, strKompleteSpace + msgKompleteQuote + strKompleteSpace + GetClipboardText () + strKompleteSpace + msgKompleteQuote + strKompleteFullStop + strKompleteSpace + msgKompleteSaveFile, OT_STRING)
Else
	SayUsingVoice(VCTX_MESSAGE, msgKompleteReviewSavePatchNameError, OT_STRING)
EndIf
EndIf
EndScript

Script AltPKey ()
ProgramsMenu ()
EndScript

Script AltLKey ()
PluginMenu ()
EndScript

; UIA
Object Function GetElementFromNameAndLocal (String strElementName, String strLocalizedTypeControl)
Var
	Object oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest"),
		Object oElement = oUIA.GetElementFromHandle(GetRealWindow(GetFocus())),
			Object oCondition1 = oUIA.CreateStringPropertyCondition(UIA_NamePropertyId, strElementName),
			Object oCondition2 = oUIA.CreateStringPropertyCondition(UIA_LocalizedControlTypePropertyId, strLocalizedTypeControl),			
				Object oAndCondition = oUIA.CreateAndCondition(oCondition1, ocondition2),
	Object oControl = oElement.FindFirst(TreeScope_Descendants, oAndCondition)
				
	Return oControl
EndFunction


Void Function ProgramsMenu ()
Var
	Int nX,
		Int nY,
	Object oProgramsMenu = GetElementFromNameAndLocal (strPrograms, strMenuItem)
If (oProgramsMenu) Then
; using the clickable points here, as invoke doesn't work
oProgramsMenu.GetClickablePoint(IntRef(nX), IntRef(nY))
SaveCursor()
JAWSCursor()
MoveTo(nX, nY)
LeftMouseButton()
RestoreCursor()
EndIf
EndFunction

Void Function PluginMenu ()
Var
	Int nX,
		Int nY,
	Object oPluginMenu = GetElementFromNameAndLocal (strPlugin2, strMenuItem)
If (oPluginMenu) Then
; using the clickable points here, as invoke doesn't work
oPluginMenu.GetClickablePoint(IntRef(nX), IntRef(nY))
SaveCursor()
JAWSCursor()
MoveTo(nX, nY)
LeftMouseButton()
RestoreCursor()
EndIf
EndFunction

; blocked keys

; block keys

Script BackspaceKey ()
SayCurrentScriptKeyLabel()
EndScript

Script CommaKey ()
SayCurrentScriptKeyLabel()
EndScript

Script LeftBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script RightBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script F1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F10Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F11Key ()
SayCurrentScriptKeyLabel()
EndScript

Script F12Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltAKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltBKey()
SayCurrentScriptKeyLabel()
EndScript

Script AltCKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltDKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltEKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltFKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltGKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltHKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltIKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltJKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltKKey ()
SayCurrentScriptKeyLabel()
EndScript


Script AltMKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltNKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltOKey ()
SayCurrentScriptKeyLabel()
EndScript


Script AltQKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltRKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltSKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltTKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltUKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltVKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltWKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltXKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltYKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltZKey ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Alt0Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltDashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltEqualsKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltBackspaceKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltSlashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltCommaKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltLeftBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltRightBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF10Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF11Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltF12Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftAKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftBKey()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftCKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftDKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftEKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftFKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftGKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftHKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftIKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftJKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftKKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftLKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftMKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftNKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftOKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftPKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftQKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftRKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftSKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftTKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftUKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftVKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftWKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftXKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftYKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftZKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShift0Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftDashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftEqualsKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftBackspaceKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftSlashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftCommaKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftLeftBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftRightBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF10Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF11Key ()
SayCurrentScriptKeyLabel()
EndScript

Script AltShiftF12Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltAKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltBKey()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltCKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltDKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltEKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltFKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltGKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltHKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltIKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltJKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltKKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltLKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltMKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltNKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltOKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltPKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltQKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltRKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltSKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltTKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltUKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltVKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltWKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltXKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltYKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltZKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAlt0Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltDashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltEqualsKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltBackspaceKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltSlashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltCommaKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltLeftBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltRightBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF10Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF11Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltF12Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlBKey()
SayCurrentScriptKeyLabel()
EndScript

Script ControlCKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlDKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlEKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlFKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlGKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlHKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlIKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlJKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlKKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlLKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlMKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlNKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlOKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlPKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlQKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlRKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlSKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlTKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlUKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlVKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlWKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlXKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlYKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlZKey ()
SayCurrentScriptKeyLabel()
EndScript

Script Control1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script Control0Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlDashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlEqualsKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlBackspaceKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlSlashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlCommaKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlLeftBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlRightBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF10Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF11Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlF12Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftAKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftBKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftCKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftDKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftEKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftFKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftGKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftHKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftIKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftJKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftKKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftLKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftMKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftNKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftOKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftPKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftQKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftRKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftSKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftTKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftUKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftVKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftWKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftXKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftYKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftZKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShift0Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftDashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftEqualsKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftBackspaceKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftSlashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftCommaKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftLeftBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftRightBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF10Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF11Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlShiftF12Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftAKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftBKey()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftCKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftDKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftEKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftFKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftGKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftHKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftIKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftJKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftKKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftLKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftMKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftNKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftOKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftPKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftQKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftRKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftSKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftTKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftUKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftVKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftWKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftXKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftYKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftZKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShift0Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftDashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftEqualsKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftBackspaceKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftSlashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftCommaKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftLeftBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftRightBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF6Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF10Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF11Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ControlAltShiftF12Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftBackspaceKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftSlashKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftCommaKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftLeftBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftRightBracketKey ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF1Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF2Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF3Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF4Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF5Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF6Key ()
TypeCurrentScriptKey()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF7Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF8Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF9Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF10Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF11Key ()
SayCurrentScriptKeyLabel()
EndScript

Script ShiftF12Key ()
SayCurrentScriptKeyLabel()
EndScript



